jersey.repackaged.org.objectweb.asm

## Class ClassVisitor

- java.lang.Object
- - jersey.repackaged.org.objectweb.asm.ClassVisitor

Direct Known Subclasses:
  ClassWriter

    public abstract class ClassVisitor
    extends Object

A visitor to visit a Java class. The methods of this class must be called in the following order: `visit` [ `visitSource` ] [ `visitModule` ][ `visitNestHost` ][ `visitPermittedSubclass` ][ `visitOuterClass` ] ( `visitAnnotation` | `visitTypeAnnotation` | `visitAttribute` )* ( `visitNestMember` | `visitInnerClass` | `visitRecordComponent` | `visitField` | `visitMethod` )* `visitEnd`.

Author:
  Eric Bruneton

### Field Summary

Fields
`protected int` `api` The ASM API version implemented by this visitor.
`protected ClassVisitor` `cv` The class visitor to which this visitor must delegate method calls.

### Constructor Summary

Constructors
Constructor and Description
`ClassVisitor(int api)` Constructs a new `ClassVisitor`.
`ClassVisitor(int api, ClassVisitor classVisitor)` Constructs a new `ClassVisitor`.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
`AnnotationVisitor` `visitAnnotation(String descriptor, boolean visible)` Visits an annotation of the class.
`void` `visitAttribute(Attribute attribute)` Visits a non standard attribute of the class.
`void` `visitEnd()` Visits the end of the class.
`FieldVisitor` `visitField(int access, String name, String descriptor, String signature, Object value)` Visits a field of the class.
`void` `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
`MethodVisitor` `visitMethod(int access, String name, String descriptor, String signature, String[] exceptions)` Visits a method of the class.
`ModuleVisitor` `visitModule(String name, int access, String version)` Visit the module corresponding to the class.
`void` `visitNestHost(String nestHost)` Visits the nest host class of the class.
`void` `visitNestMember(String nestMember)` Visits a member of the nest.
`void` `visitOuterClass(String owner, String name, String descriptor)` Visits the enclosing class of the class.
`void` `visitPermittedSubclass(String permittedSubclass)` Visits a permitted subclasses.
`RecordComponentVisitor` `visitRecordComponent(String name, String descriptor, String signature)` Visits a record component of the class.
`void` `visitSource(String source, String debug)` Visits the source of the class.
`AnnotationVisitor` `visitTypeAnnotation(int typeRef, TypePath typePath, String descriptor, boolean visible)` Visits an annotation on a type in the class signature.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### api

    protected final int api

The ASM API version implemented by this visitor. The value of this field must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6` or `Opcodes.ASM7`.

#### cv

    protected ClassVisitor cv

The class visitor to which this visitor must delegate method calls. May be null.

### Constructor Detail

#### ClassVisitor

    public ClassVisitor(int api)

Constructs a new `ClassVisitor`.

Parameters:
  `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6` or `Opcodes.ASM7`.

#### ClassVisitor

    public ClassVisitor(int api,
                        ClassVisitor classVisitor)

Constructs a new `ClassVisitor`.

Parameters:
  `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6`, `Opcodes.ASM7`, `Opcodes.ASM8` or `Opcodes.ASM9`.
  `classVisitor` - the class visitor to which this visitor must delegate method calls. May be null.

### Method Detail

#### visit

    public void visit(int version,
                      int access,
                      String name,
                      String signature,
                      String superName,
                      String[] interfaces)

Visits the header of the class.

Parameters:
  `version` - the class version. The minor version is stored in the 16 most significant bits, and the major version in the 16 least significant bits.
  `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated `Opcodes.ACC_DEPRECATED` or a record `Opcodes.ACC_RECORD`.
  `name` - the internal name of the class (see `Type.getInternalName()`).
  `signature` - the signature of this class. May be null if the class is not a generic one, and does not extend or implement generic classes or interfaces.
  `superName` - the internal of name of the super class (see `Type.getInternalName()`). For interfaces, the super class is `Object`. May be null, but only for the `Object` class.
  `interfaces` - the internal names of the class's interfaces (see `Type.getInternalName()`). May be null.

#### visitSource

    public void visitSource(String source,
                            String debug)

Visits the source of the class.

Parameters:
  `source` - the name of the source file from which the class was compiled. May be null.
  `debug` - additional debug information to compute the correspondence between source and compiled elements of the class. May be null.

#### visitModule

    public ModuleVisitor visitModule(String name,
                                     int access,
                                     String version)

Visit the module corresponding to the class.

Parameters:
  `name` - the fully qualified name (using dots) of the module.
  `access` - the module access flags, among `ACC_OPEN`, `ACC_SYNTHETIC` and `ACC_MANDATED`.
  `version` - the module version, or null.
Returns:
  a visitor to visit the module values, or null if this visitor is not interested in visiting this module.

#### visitNestHost

    public void visitNestHost(String nestHost)

Visits the nest host class of the class. A nest is a set of classes of the same package that share access to their private members. One of these classes, called the host, lists the other members of the nest, which in turn should link to the host of their nest. This method must be called only once and only if the visited class is a non-host member of a nest. A class is implicitly its own nest, so it's invalid to call this method with the visited class name as argument.

Parameters:
  `nestHost` - the internal name of the host class of the nest.

#### visitOuterClass

    public void visitOuterClass(String owner,
                                String name,
                                String descriptor)

Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.

Parameters:
  `owner` - internal name of the enclosing class of the class.
  `name` - the name of the method that contains the class, or null if the class is not enclosed in a method of its enclosing class.
  `descriptor` - the descriptor of the method that contains the class, or null if the class is not enclosed in a method of its enclosing class.

#### visitAnnotation

    public AnnotationVisitor visitAnnotation(String descriptor,
                                             boolean visible)

Visits an annotation of the class.

Parameters:
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

#### visitTypeAnnotation

    public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                                 TypePath typePath,
                                                 String descriptor,
                                                 boolean visible)

Visits an annotation on a type in the class signature.

Parameters:
  `typeRef` - a reference to the annotated type. The sort of this type reference must be `TypeReference.CLASS_TYPE_PARAMETER`, `TypeReference.CLASS_TYPE_PARAMETER_BOUND` or `TypeReference.CLASS_EXTENDS`. See `TypeReference`.
  `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole.
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

#### visitAttribute

    public void visitAttribute(Attribute attribute)

Visits a non standard attribute of the class.

Parameters:
  `attribute` - an attribute.

#### visitNestMember

    public void visitNestMember(String nestMember)

Visits a member of the nest. A nest is a set of classes of the same package that share access to their private members. One of these classes, called the host, lists the other members of the nest, which in turn should link to the host of their nest. This method must be called only if the visited class is the host of a nest. A nest host is implicitly a member of its own nest, so it's invalid to call this method with the visited class name as argument.

Parameters:
  `nestMember` - the internal name of a nest member.

#### visitPermittedSubclass

    public void visitPermittedSubclass(String permittedSubclass)

Visits a permitted subclasses. A permitted subclass is one of the allowed subclasses of the current class.

Parameters:
  `permittedSubclass` - the internal name of a permitted subclass.

#### visitInnerClass

    public void visitInnerClass(String name,
                                String outerName,
                                String innerName,
                                int access)

Visits information about an inner class. This inner class is not necessarily a member of the class being visited.

Parameters:
  `name` - the internal name of an inner class (see `Type.getInternalName()`).
  `outerName` - the internal name of the class to which the inner class belongs (see `Type.getInternalName()`). May be null for not member classes.
  `innerName` - the (simple) name of the inner class inside its enclosing class. May be null for anonymous inner classes.
  `access` - the access flags of the inner class as originally declared in the enclosing class.

#### visitRecordComponent

    public RecordComponentVisitor visitRecordComponent(String name,
                                                       String descriptor,
                                                       String signature)

Visits a record component of the class.

Parameters:
  `name` - the record component name.
  `descriptor` - the record component descriptor (see `Type`).
  `signature` - the record component signature. May be null if the record component type does not use generic types.
Returns:
  a visitor to visit this record component annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

#### visitField

    public FieldVisitor visitField(int access,
                                   String name,
                                   String descriptor,
                                   String signature,
                                   Object value)

Visits a field of the class.

Parameters:
  `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
  `name` - the field's name.
  `descriptor` - the field's descriptor (see `Type`).
  `signature` - the field's signature. May be null if the field's type does not use generic types.
  `value` - the field's initial value. This parameter, which may be null if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
Returns:
  a visitor to visit field annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

#### visitMethod

    public MethodVisitor visitMethod(int access,
                                     String name,
                                     String descriptor,
                                     String signature,
                                     String[] exceptions)

Visits a method of the class. This method must return a new `MethodVisitor` instance (or null) each time it is called, i.e., it should not return a previously returned visitor.

Parameters:
  `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
  `name` - the method's name.
  `descriptor` - the method's descriptor (see `Type`).
  `signature` - the method's signature. May be null if the method parameters, return type and exceptions do not use generic types.
  `exceptions` - the internal names of the method's exception classes (see `Type.getInternalName()`). May be null.
Returns:
  an object to visit the byte code of the method, or null if this class visitor is not interested in visiting the code of this method.

#### visitEnd

    public void visitEnd()

Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.